<bugID>1109869<Summary>[e10s] [meta] Eliminate uses of "unexpected" CPOWs in Firefox</Summary><Description>Unexpected CPOWs are CPOWs that are sent when the content process isn't known to be blocking on the parent. For example, CPOWs used when constructing the context menu are *not* unexpected because the child process is known to be blocking here:
  http://mxr.mozilla.org/mozilla-central/source/browser/base/content/content.js?rev=81daac845113#125

We use lots of unexpected CPOWs though. Searching for "AsCPOW" yields many hits. Here are some examples:

1. Session store flush operations send unexpected CPOWs when closing a tab or a window. This can cause jank.

2. isTabEmpty can send unexpected CPOWs.

3. Any access to browser.sessionHistory sends a CPOW, such as the back/fwd buttons.

4. The page style menu.

5. Selecting some context menu operations uses CPOWs. Examples are "View Source" and "Save Page As".

6. The Page Info window.

Unexpected CPOWs can cause jank and we'd like to phase them out over time. We should fix these in order of how often they're used.

In some cases unexpected CPOWs can be turned into expected CPOWs by synchronizing with the child process first. In other cases it's probably easier to avoid CPOWs entirely. Much of the UI work can be done by hiding menus until we've received a response from the child while still processing events.</Description></bugID>